package com.example.listviewobjectjson;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLEncoder;
import java.util.List;

import com.google.gson.Gson;

import android.os.AsyncTask;
import android.os.Bundle;
import android.os.Handler;
import android.app.Activity;
import android.util.Log;
import android.view.Menu;
import android.view.View;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;

public class MyListview extends Activity {
	
	private Gson gson = null;
	private WebGet task;
	private JSON_STRING js;
	private ArrayAdapter<MyObject> basicAdapter;
	
	// ************************************************************
	// Android p
	// ************************************************************
	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.activity_my_listview);

		Button button = (Button) findViewById(R.id.button1);
		button.setOnClickListener(new View.OnClickListener() {
			@Override
			public void onClick(View v) {
				// AsyncTask@Ɉ^ČĂяo
				// 1) doInBackground, 2) onProgressUpdate, 3) onPostExecute
				task = new WebGet();
				task.execute( "http://10.0.2.2/lightbox/php_json/log.php" );
			}
		});
 	}
	
	// ************************************************************
	// Android p񓯊
	// ************************************************************
	private class WebGet extends AsyncTask<String, String, String> {
		
		// ͎gĂ܂
		@Override
		protected void onPreExecute() {
			super.onPreExecute();
		}
		
		// *******************************************************
		// UI Xbh̏ ( ́@JSON  )
		// *******************************************************
		@Override
		protected void onPostExecute(String result) {
			// UI XbhƂď
			System.out.println(result);

			// gson CX^X
			gson = new Gson();
			
			// JSON  NXCX^Xɕϊ
			js = gson.fromJson(result,JSON_STRING.class);
			
			// js.item  List<MyObjecyt>
			basicAdapter = new ArrayAdapter<MyObject>(
					MyListview.this,
					R.layout.textview,
					js.item
			);
			
			// Xgr[ɃA_v^Zbg
			ListView listView = (ListView)MyListview.this.findViewById(R.id.listView1);
			listView.setAdapter(basicAdapter);			

		}

		// *******************************************************
		// 񓯊XbȟĂяo
		// *******************************************************
		@Override
		protected String doInBackground(String... aurl) {

			Log.i("MyListview2:","Jn");
			String json_string = "";

			try {

				//  URL gpĎs
				URL url = new URL(aurl[0]);
				// ڑIuWFNg( getInputStream ׂ̂ )
				HttpURLConnection http = (HttpURLConnection)url.openConnection();
				http.setConnectTimeout(30000);
				http.setReadTimeout(30000);
				http.setRequestMethod("GET");
				
				// ȉǂݍ݂RZbg
				InputStream i_stream = http.getInputStream();
				// UTF-8 Ń[_[쐬
				InputStreamReader i_stream_reader = new InputStreamReader(i_stream, "UTF-8");
				// sPʂœǂݍވׂ̏   
				BufferedReader b_reader = new BufferedReader(i_stream_reader);
				
				// s̈ꊇǂ݂
				String line_buffer;   
				// BufferedReader ́AreadLine  null ԂƓǂݍݏI 
				while ( null != (line_buffer = b_reader.readLine() ) ) {   
					// R}hvvgɕ\   
					json_string += line_buffer;
				}
	 
				// ㏈
				b_reader.close();
				i_stream_reader.close();
				i_stream.close();

				http.disconnect();
			}
			catch (Exception e) {
				e.printStackTrace();
			}
			
			// JSON  onPostExecute ɑ΂đ
			return json_string;
		}

	}	
	
	// ************************************************************
	// GSON Ŏgׂ JSON ̍\`NX
	// ************************************************************
	private class JSON_STRING {
		List<MyObject> item;
	}

	private class MyObject {
		String text;
		
		// PXgr[Ȃ̂ŁAtoString  eԂ悤ɂĂ
		public String toString() {
			return this.text;
		}
	}
	
	// ************************************************************
	// j[( gp )
	// ************************************************************
	@Override
	public boolean onCreateOptionsMenu(Menu menu) {
		getMenuInflater().inflate(R.menu.activity_my_listview, menu);
		return true;
	}
}
